require 'evrone/common/rack/builder'

module Evrone
  module CI
    module Common
      module Helper
        module Middlewares

          def self.included(base)
            base.send :extend, ClassMethods
          end

          def run_middlewares(*args, &block)
            self.class.builder.to_app(block).call(*args)
          end
          private :run_middlewares

          module ClassMethods

            attr_reader :builder

            def middlewares(&block)
              @builder = Evrone::Common::Rack::Builder.new(&block)
            end

          end

        end
      end
    end
  end
end

