module Evrone
  module CI
    module SCM

      class Git

        class GitSSH

          include Common::Helper::Shell

          attr_reader :deploy_key

          def initialize(deploy_key)
            @deploy_key = deploy_key
          end

          def open
            begin
              yield create
            ensure
              destroy
            end
          end

          def create
            key_location
            location
          end

          def destroy
            key_location.unlink if key_location
            location.unlink
            @location     = nil
            @key_location = nil
          end

          def location
            @location ||= write_tmp_file 'git', template, 0700
          end

          def key_location
            if deploy_key
              @key_location ||= write_tmp_file 'key', deploy_key, 0600
            end
          end

          def template
            key = key_location ? "-i #{key_location.path}" : ""
            out = ['#!/bin/sh']
            out << "exec /usr/bin/ssh -A -o StrictHostKeyChecking=no #{key} $@"
            out.join "\n"
          end

        end
      end
    end
  end
end
